#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>
#include <windows.h>
#include "tad_palavra.h"
#include "common.h"

/* dado um arquivo, verifica quantas palavras ha nele */
int conta_palavras_arq(FILE *p)
{
    int num_palavras=0, flag_letra=0,n_letras_lidas,i_buffer;
    unsigned char buffer[1024],buffer_letra;

    //conta o numero de palavras no arquivo
    while (!feof(p))
    {
        //le letras do arquivocarmazenando-as em um buffer
        n_letras_lidas = fread(buffer,sizeof(buffer_letra),sizeof(buffer),p);

         //passa caractere por caractere para as palavras e entao para o dicionario
        for(i_buffer=0; i_buffer < n_letras_lidas; i_buffer++)
        {
            //verifica se era caractere valido
            if(verifica_letra(buffer[i_buffer]))
            {
                flag_letra = 1;
            }
            //caractere invalido e tinha inicializado uma palavra
            else if(flag_letra)
            {
                num_palavras++;
                flag_letra=0;
            }
        }
    }

    //verifica se o EOF impediu de contar a ultima palavra
    if(flag_letra)
    {
        num_palavras++;
    }

    //volta o arquivo para o inicio
    rewind(p);

    return num_palavras;
}

/* lista todos os itens de uma pasta */
int listdir(char path[], char paths[20][100])
{
    struct dirent *item;
    DIR *dp;
    int i=0;

    dp = opendir(path);

    if (dp == NULL)
    {
        printf("Erro ao listar pasta.");
        return -1;
    }

    while((item = readdir(dp)))
    {
        if(strcmp(item->d_name,".") != 0 && strcmp(item->d_name,"..") != 0)
        {
            printf("%2d - %s\n",i+1,item->d_name);
            strcpy(paths[i],item->d_name);
            i++;
        }
    }

    closedir(dp);
    return 0;
}

/* exibe uma mensagem e espera uma tecla */
void pause()
{
    printf("Pressione <enter> para continuar...");
    fflush(stdin);
    getchar();
}

/* limpa a tela */
void clear_screen()
{
    system( "cls" );
    gotoxy(0,0);
}

/* Posiciona o cursor em uma certa linha e coluna do terminal */
void gotoxy(int x, int y)
{
    COORD coord;
    HANDLE handle;
    handle = GetStdHandle(STD_OUTPUT_HANDLE);
    coord.X = x;
    coord.Y = y;
    SetConsoleCursorPosition(handle, coord);
}
