/*
* TRABALHO FINAL DE ESTRUTURA DE DADOS - PARTE 1
*
* Projeto de conclusao de semestre de Estrutura de Dados
* Ciencia da Computacao - UFRGS 2011/2
*
* Autores:
* Adolfo Schneider
* Lucas Jose Kreutz Alves
*
* Compilador: GNU GCC Compiler
* IDE: CodeBlocks 10.05
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <windows.h>
#include <ctype.h>
#include "common.h"
#include "tad_palavra.h"
#include "tad_dicionario.h"
#include "tad_texto.h"
#include "tad_erros.h"

int main()
{
    time_t start,end;
    PtDic *dicionario;
    PtTexto *texto;
    PtErro  *erro;
    TipoPalavra  palavra_texto[MAX];
    int tex_escolhido,dic_escolhido, k, encerrar=0;
    char dicionarios[20][100],textos[20][100],encerrar_prompt;

    //prompt escolha do dicionario
    printf("Escolha o dicionario:\n--\n");
    listdir("./dicionarios",dicionarios);
    printf("--\nEscolha: ");
    scanf(" %d",&dic_escolhido);
    dic_escolhido--;
    clear_screen();

    //incializa o dicionario
    dicionario = incializa_dic();

    //carregamento do dicionario
    printf("Lendo o dicionario %s...\n",dicionarios[dic_escolhido]);
    time (&start);
    dicionario=ler_dic(dicionario,dicionarios[dic_escolhido]);
    time (&end);
    printf("Carregado!\n");
    printf("\nTempo para carregar o dicionario: %.2lfs\n\n\n", difftime(end,start));
    pause();

    do
    {
        clear_screen();

        //prompt escolha do texto
        printf("Escolha o texto\n--\n");
        listdir("./textos",textos);
        printf("--\nEscolha: ");
        scanf(" %d",&tex_escolhido);
        tex_escolhido--;
        clear_screen();

        //prompt defina o K
        printf ("Valor de K: ");
        scanf (" %d", &k);
        clear_screen();

        //carregamento do texto
        printf("Lendo o texto %s...\n",textos[tex_escolhido]);
        texto = incializa_texto();
        texto=ler_texto(texto,textos[tex_escolhido]);
        clear_screen();

        //Montando lista de palavras erradas
        printf("Verificando o texto...\n");
        erro=cria_lista();
        time (&start);
        while (pop_texto(&texto,palavra_texto))
        {
            if (!pesquisa_palavra(dicionario,palavra_texto))
            {
                erro=insere_ord(erro,palavra_texto);
            }
        }
        time (&end);
        printf("Verificado!\n");
        printf("\nTempo para encontrar os erros: %.2lfs\n\n\n", difftime (end,start));
        pause();
        clear_screen();

        //Imprime a listagem de palavras erradas e frequencias
        if (k<=0)
            imprime(erro);
        else
            imprime_k(erro,k);

        //destrua todas as evidencias!
        texto = destroi_texto(texto);
        erro = destroi(erro);

        pause();
        clear_screen();

        printf("Deseja carregar outro texto? [s/n] ");
        fflush(stdin);
        encerrar_prompt=getchar();

        while(tolower(encerrar_prompt)!='s' && tolower(encerrar_prompt)!='n')
        {
            printf("\nResposta invalida. [s/n]: ");
            fflush(stdin);
            encerrar_prompt=getchar();
        }

        encerrar = (encerrar_prompt=='s' || encerrar_prompt=='S')?0:1;

    }while(!encerrar);

    //destrua o dicionario!
    dicionario = destroi_dic(dicionario);

    return 0;
}
