#ifndef TAD_DICIONARIO_H_INCLUDED
#define TAD_DICIONARIO_H_INCLUDED

#include "tad_palavra.h"

/*
Um TipoDicionario eh uma ABP que armazena as palavras como LSE
*/
typedef struct TipoDicionario PtDic;
struct TipoDicionario{
        TipoPalavra palavra[MAX];
        PtDic *esq;
        PtDic *dir;
        int altura;
};


PtDic* rotacao_direita(PtDic *d);
PtDic* rotacao_esquerda(PtDic *d);
PtDic* rotacao_dupla_direita (PtDic *d);
PtDic* rotacao_dupla_esquerda (PtDic *d);
int calc_fator(PtDic *d);
int get_altura(PtDic *d);
int conta_nodos(PtDic *d);
int verifica_balancemento(PtDic *d);
PtDic* incializa_dic(void);
PtDic* ler_dic(PtDic* d, char dic[]);
PtDic* insere_palavra_dic(PtDic *d, TipoPalavra p[MAX]);
PtDic* insere_palavra_dic_r(PtDic *d, TipoPalavra p[MAX],int *balanceou);
int calc_altura(PtDic *a);
void imprime_dicionario(PtDic *d, int altura);
int pesquisa_palavra (PtDic *d, char pal[MAX]);
PtDic* destroi_dic(PtDic* d);




#endif // TAD_DICIONARIO_H_INCLUDED
