#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tad_texto.h"
#include "tad_palavra.h"
#include "extchar.h"

/*
As palavras contidas no texto sao todas armazenadas em uma pilha,
pois, assim, fica mais facil percorre-lo
*/

/* inicializa o ponteiro da pilha */
PtTexto* incializa_texto(void)
{
    return NULL;
}

/* checa se a pilha esta vazia */
int vazia(PtTexto *topo)
{
    if (topo==NULL)
        return 1;

    return 0;
}

/* Importa as palavras de um texto para a pilha */
PtTexto* ler_texto(PtTexto* t, char tex[])
{
    unsigned char buffer[1024],buffer_letra;
    TipoPalavra palavra[MAX];
    FILE *p=NULL;
    char pasta[]= "textos/";
    int i=0,i_buffer=0,n_letras_lidas;


    //abre o arquivo conforme a escolha realizada
    p=fopen(strcat(pasta,tex),"r");

    // verifica se abriu o arquivo corretamente
    if (p != NULL)
    {
        //inicializa a palavra temporaria
        cria_palavra(palavra);

        //le palavra (chamar a funo que vai botar na rvore)
        while (!feof(p))
        {
            //le letras do arquivocarmazenando-as em um buffer
            n_letras_lidas = fread(buffer,sizeof(buffer_letra),sizeof(buffer),p);

            //passa caractere por caractere para as palavras e entao para o dicionario
            for(i_buffer=0; i_buffer < n_letras_lidas; i_buffer++)
            {
                buffer_letra=buffer[i_buffer];

                //verifica se era caractere valido
                if(verifica_letra(buffer_letra))
                {
                    insere_letra(palavra, buffer_letra);
                }
                //caractere invalido e tinha inicializado uma palavra
                else if(strlen(palavra)>0)
                {
                    i++;
                    //insere a palavra no dicionario
                    t = push_texto(t, palavra);
                    //reinicia a palavra temporaria
                    cria_palavra(palavra);
                }
            }
        }

        //verifica se a ultima palavra ficou pendente por ter alcancado o EOF
        if(strlen(palavra)>0)
        {
            //insere a ultima palavra
            t = push_texto(t, palavra);
        }

        printf("Palavras inseridas: %d\n",i);

        fclose(p);
    }
    else
    {
        printf("Erro ao abrir o arquivo do texto!\n");
    }

    return t;
}

/* imprimir a pilha do texto */
void imprime_texto(PtTexto *topo)
{
    PtTexto *ptaux;

    if (topo != NULL)
    {
        for (ptaux=topo; ptaux!=NULL; ptaux=ptaux->elo)
        {
            imprime_palavra(ptaux->palavra);
            printf(" ");
        }
    }
    else
        puts("Pilha vazia");
}

/* operacao de push (insere valor) */
PtTexto* push_texto(PtTexto *topo, TipoPalavra dado[])
{
    PtTexto *novo; //novo elemento

    /*aloca um novo nodo */
    novo = (PtTexto*) malloc(sizeof(PtTexto));
    novo->elo = NULL;

    /*insere a informao no novo nodo*/
    strcpy(novo->palavra, dado);

    /*encaeia o elemento*/
    novo->elo = topo;
    topo = novo;

    return topo;
}

/* operacao de pop (retorno de valor) */
int pop_texto(PtTexto **topo, TipoPalavra dado[]) //retorna 1 se exclui e zero se no exclui
{
    PtTexto* ptaux;

    if (*topo == NULL)
        return 0;   //no tem nada na pilha
    else
    {
        strcpy(dado,(*topo)->palavra);     // devolve o valor do topo
        ptaux = *topo;          //guarda o endereo do topo
        *topo = (*topo)->elo;     //o prximo passa a ser o topo
        free(ptaux);           //libera o que estava no topo
        ptaux=NULL;
        return 1;
    }
}

/* destroi a pilha do texto */
PtTexto* destroi_texto(PtTexto *topo)
{
    PtTexto *ptaux;

    while (topo != NULL)
    {
        ptaux = topo;          //guarda o endereo do topo
        topo = topo->elo;     //o prximo passa a ser o topo
        free(ptaux);           //libera o que estava no topo
    }
    return NULL;
}
